//    DirectDraw (c 8- )

#include "game_krn.h"

extern char* ErrStrDDR(int num);

HRESULT dd_res;  //  DD
LPDIRECTDRAW dd_obj; // DirecDraw
LPDIRECTDRAWSURFACE dd_surf; // 
LPDIRECTDRAWSURFACE dd_buff; // 
LPDIRECTDRAWSURFACE dd_buff_RAM; //   RAM
DDSURFACEDESC dd_sd;
DDSCAPS dds_caps;
DDCAPS dd_caps;

LPDIRECTDRAWPALETTE dd_pal; //
PALETTEENTRY pal256[256];
DDCOLORKEY dd_ckey; // 

void * surf_vmem; //  
void * buff_vmem; //  
void * buff_RAM; //     RAM

int cur_vmode=5;//NUM_of_modes;
int vmem_total;// 
BOOL v_modes[NUM_of_modes]; // 

V_PARM v_parm [NUM_of_modes]= {
	{320,240,8},
	{512,384,8},
	{640,480,8},
	{800,600,8},
	{1024,768,8},
	{1152,864,8},
	{1280,1024,8},
	{1600,1200,8},
};
BOOL isVideoBuffer; //   - (TRUE),   (FALSE)

//-------------------//
//    		 //
//-------------------//

HRESULT CALLBACK CallBackEDM(LPDDSURFACEDESC lpDDSD,LPVOID lpctx) //   
{
    DWORD w   = lpDDSD->dwWidth;
    DWORD h   = lpDDSD->dwHeight;
    DWORD bpp = lpDDSD->ddpfPixelFormat.dwRGBBitCount;

	 for (int i=0;i<NUM_of_modes;i++)
		 if (w==v_parm[i].w
			  && h==v_parm[i].h
			  && bpp==v_parm[i].bpp) v_modes[i]=TRUE;

	 return DDENUMRET_OK;

}

//------------------

void CloseDDR()  //   DDraw
{
	if(dd_buff_RAM!=NULL) dd_buff_RAM->Release();
	if(dd_surf!=NULL) dd_surf->Release();
	if(dd_obj!=NULL) dd_obj->Release();

	return;
}

//------------------

void UserErrorDDR(char *err_str)
{
	Msg("DD_ERROR (User): %s",err_str);
}

//------------------

void ErrorDDR(char* err_pos)
{
	Msg("DD_ERROR (%s): %s",err_pos,ErrStrDDR(dd_res));
}

//------------------

BOOL SetModeDDR(int set_vmode) //  
// 0-640X480, 1-800x600, 2-1024x768, 3-1152x864
{
	  // ?
	if (v_modes[set_vmode]==FALSE)
		{
		//	Msg("VideoModes %ux%u is not available",v_parm[set_vmode].w,v_parm[set_vmode].h);
			return FALSE;
		}

	  // 
	dd_res=dd_obj->SetDisplayMode(v_parm[set_vmode].w, v_parm[set_vmode].h, v_parm[set_vmode].bpp);
	if(dd_res!=DD_OK) {ErrorDDR("setmode1"); return FALSE;}

	  //  
	dd_sd.dwSize=sizeof(DDSURFACEDESC);
	dd_sd.dwFlags=DDSD_BACKBUFFERCOUNT | DDSD_CAPS;
	dd_sd.dwBackBufferCount=1;
	dd_sd.ddsCaps.dwCaps=DDSCAPS_FLIP | DDSCAPS_PRIMARYSURFACE | DDSCAPS_COMPLEX;
	if(dd_surf!=NULL) dd_surf->Release();
	dd_res=dd_obj->CreateSurface(&dd_sd,&dd_surf,NULL);
	if(dd_res!=DD_OK) {/*ErrorDDR("setmode2")*/; return FALSE;}

	  //   
	dds_caps.dwCaps=DDSCAPS_BACKBUFFER | DDSCAPS_VIDEOMEMORY;
	dd_res=dd_surf->GetAttachedSurface(&dds_caps,&dd_buff);
	if(dd_res!=DD_OK) {/*ErrorDDR("setmode3")*/; return FALSE;}

	  // 
	if(!SetPaletteDDR(0)) return FALSE;

	  // 
	cur_vmode=set_vmode;
	return TRUE;
}

//-------------------

BOOL ChangeModeDDR() //   3,2,1,0,3,2,1,0,...
{
	do
	{
		if(cur_vmode==0) cur_vmode=NUM_of_modes-1;
		else cur_vmode--;
		if(SetModeDDR(cur_vmode)) return TRUE;
	}
	while(cur_vmode>0);
	UserErrorDDR("Set Video Mode Fatal Error!");
	return FALSE;
}

//-------------------

BOOL OpenDDR() //   
{
	int i;

	  //  DD,     
    if (dd_obj!=NULL) return TRUE;
    dd_res=DirectDrawCreate(NULL,&dd_obj,NULL);
    if(dd_res!=DD_OK) {ErrorDDR("open1"); return FALSE;}


      //  
    dd_res=dd_obj->SetCooperativeLevel(hwnd,
			  DDSCL_ALLOWMODEX |
              DDSCL_ALLOWREBOOT |
			  DDSCL_EXCLUSIVE |
			  DDSCL_FULLSCREEN );
    if(dd_res!=DD_OK) {ErrorDDR("open2"); return FALSE;}

      //  
	for(i=0; i<NUM_of_modes;i++) v_modes[i]=FALSE;
	dd_res=dd_obj->EnumDisplayModes(0,NULL,0,CallBackEDM);
	if(dd_res!=DD_OK) {ErrorDDR("open3"); return FALSE;}

	  //  
	if(!ChangeModeDDR()) return FALSE;

	  //OK
	return TRUE;
}

//-------------------

DWORD LockDDR()
{
	ZeroMemory(&dd_sd,sizeof(DDSURFACEDESC));
	dd_sd.dwSize=sizeof(DDSURFACEDESC);
	do
	{
		dd_res=dd_surf->Lock(NULL,&dd_sd,DDLOCK_SURFACEMEMORYPTR,NULL);
		if (dd_res==DDERR_SURFACELOST)
		{	 
		  dd_surf->Restore();  
		}
	} while (dd_res==DDERR_WASSTILLDRAWING);
	surf_vmem=dd_sd.lpSurface;
	return dd_res;
}

//-------------------

void UnlockDDR()
{
	dd_res=dd_surf->Unlock(surf_vmem);
	if(dd_res==DD_OK) return;
	ErrorDDR("unlock1");
}

//-------------------

DWORD LockBackBufDDR()
{
	ZeroMemory(&dd_sd,sizeof(DDSURFACEDESC));
	dd_sd.dwSize=sizeof(DDSURFACEDESC);
	do
	{
		dd_res=dd_buff->Lock(NULL,&dd_sd,DDLOCK_SURFACEMEMORYPTR,NULL);
		if (dd_res==DDERR_SURFACELOST)
		{	 
		  dd_buff->Restore();  
		}
	} while (dd_res==DDERR_WASSTILLDRAWING);
	buff_vmem=dd_sd.lpSurface;
	return dd_res;
}

//-------------------

void UnlockBackBufDDR()
{
	dd_res=dd_buff->Unlock(buff_vmem);
	if(dd_res==DD_OK) return;
	ErrorDDR("unlockbb1");
}

//-------------------

BOOL FlipDDR()
{
	do
	{
		dd_res=dd_surf->Flip(NULL,DDFLIP_WAIT); 
		if (dd_res==DD_OK) return TRUE;
		if (dd_res==DDERR_SURFACELOST) {dd_surf->Restore(); return TRUE;}
	} while (1);
	ErrorDDR("flip1");
	return FALSE;
}

//-------------------

BOOL ClsDDR(BYTE cl_color) // 
{
	if(LockDDR()!=DD_OK) return FALSE;
	FillMemory(surf_vmem, v_parm[cur_vmode].h*v_parm[cur_vmode].w, cl_color);
	UnlockDDR();
	return TRUE;
}

BOOL ClsBackBufDDR(BYTE cl_color) // 
{
	if(LockBackBufDDR()!=DD_OK) return FALSE;
	FillMemory(buff_vmem, v_parm[cur_vmode].h*v_parm[cur_vmode].w, cl_color);
	UnlockBackBufDDR();
	return TRUE;
}

//-------------------
BOOL SetPaletteDDR(int N) //  (N: 0-bit332, 1-level676, 2-level666)
{
	int i;

	switch (N)
	{
	case 0: 
		for( i=0; i<256; i++ )
		{
			pal256[i].peRed   = (BYTE)(((i >> 5) & 0x07) * 255 / 7);
			pal256[i].peGreen = (BYTE)(((i >> 2) & 0x07) * 255 / 7);
			pal256[i].peBlue  = (BYTE)(((i >> 0) & 0x03) * 255 / 3);
			pal256[i].peFlags = (BYTE)0;
		}
		break;
	case 1:
	case 2:
	default: UserErrorDDR("Unknown Pallete"); return FALSE;
	}

	if(dd_pal!=NULL) dd_pal->Release();
	dd_res=dd_obj->CreatePalette(DDPCAPS_8BIT,pal256,&dd_pal,NULL);
	if(dd_res!=DD_OK){ErrorDDR("setpal1"); return FALSE;}
	dd_res=dd_surf->SetPalette(dd_pal);
	if(dd_res!=DD_OK){ErrorDDR("setpal2"); return FALSE;}
	return TRUE;
}


//----------    

BOOL OpenMemBufDDR() //
{
	if(dd_buff_RAM!=NULL)
	{
		dd_buff_RAM->Release();
	}
	ZeroMemory(&dd_sd,sizeof(dd_sd));
	dd_sd.dwSize=sizeof(DDSURFACEDESC);
	dd_sd.dwFlags=DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT;
	dd_sd.ddsCaps.dwCaps=DDSCAPS_OFFSCREENPLAIN | DDSCAPS_SYSTEMMEMORY;
	dd_sd.ddpfPixelFormat.dwSize=sizeof(DDPIXELFORMAT);
	dd_sd.ddpfPixelFormat.dwFlags=DDPF_RGB | DDPF_PALETTEINDEXED8;
	dd_sd.ddpfPixelFormat.dwRGBBitCount=8;
	dd_sd.dwWidth=v_parm[cur_vmode].w;
	dd_sd.dwHeight=v_parm[cur_vmode].h;
	dd_res=dd_obj->CreateSurface(&dd_sd,&dd_buff_RAM,NULL);
	if(dd_res!=DD_OK) 
		{ErrorDDR("openmembuf1"); return FALSE;}
	return TRUE;
}


//----------    RAM     

BOOL LockMemBufDDR()
{
	ZeroMemory(&dd_sd,sizeof(DDSURFACEDESC));
	dd_sd.dwSize=sizeof(DDSURFACEDESC);
	do
	{
		dd_res=dd_buff_RAM->Lock(NULL,&dd_sd,DDLOCK_SURFACEMEMORYPTR,NULL);
		if(dd_res==DD_OK)
		{
			// 
			buff_RAM=dd_sd.lpSurface;
			return TRUE;
		}
		if(dd_res==DDERR_SURFACELOST)
		{
			// 
			dd_buff_RAM->Restore();
			continue;
		}
		if(dd_res!=DDERR_WASSTILLDRAWING) {ErrorDDR("lockmembuf1"); return FALSE;}
	} while(1);
	
}

//----------    RAM

BOOL UnlockMemBufDDR()
{
	dd_res=dd_buff_RAM->Unlock(buff_RAM);
	if(dd_res==DD_OK) return TRUE;
	ErrorDDR("unlockmembuf1");
	return FALSE;
}

//----------    RAM  

BOOL CopyMemBufDDR()
{
	RECT r={0,0,v_parm[cur_vmode].w,v_parm[cur_vmode].h};
	dd_res=dd_buff->BltFast(0,0,dd_buff_RAM,&r,DDBLTFAST_NOCOLORKEY | DDBLTFAST_WAIT);
	if(dd_res==DD_OK) return TRUE;
	if(dd_res==DDERR_SURFACELOST)
	{
		dd_buff->Restore();
		return TRUE;
	}
	ErrorDDR("copymembuf1");
	return FALSE;
}


