#ifndef __DDRAW_SUBROUTINES
#define __DDRAW_SUBROUTINES

typedef struct V_PARM
	{
		DWORD w;
		DWORD h;
		DWORD bpp;
} _V_PARM;

//-----------------

extern void * surf_vmem; //  
extern void * buff_vmem; //  

extern HRESULT dd_res;  //  DD
extern LPDIRECTDRAW dd_obj; // DirecDraw
extern LPDIRECTDRAWSURFACE dd_surf; // 
extern LPDIRECTDRAWSURFACE dd_buff; // 
extern LPDIRECTDRAWSURFACE dd_buff_RAM; //   RAM
extern DDSURFACEDESC dd_sd;
extern DDCAPS dd_caps;

extern LPDIRECTDRAWPALETTE dd_pal; //
extern PALETTEENTRY pal256[256];
extern DDCOLORKEY dd_ckey; // 

#define NUM_of_modes 8
extern void *surf_vmem; //  
extern void *buff_vmem; //  
extern void * buff_RAM; //     RAM
extern BOOL isVideoBuffer; //   - (TRUE),   (FALSE)
extern int cur_vmode; //  
extern int vmem_total;//  
extern V_PARM v_parm [NUM_of_modes];

//------------------


extern void CloseDDR();  //   DDraw
extern void ErrorDDR(char *err_pos);
extern void UserErrorDDR(char *err_str);
extern DWORD LockDDR(); //  (DD_OK - )
extern void UnlockDDR();// 
extern DWORD LockBackBufDDR(); //  (DD_OK - )
extern void UnlockBackBufDDR();// 
extern BOOL FlipDDR(); // 
extern BOOL OpenDDR(); //  
extern BOOL SetModeDDR(int set_vmode); // 
extern BOOL ChangeModeDDR(); //  
extern BOOL ClsDDR(BYTE cl_color); // 
extern BOOL ClsBackBufDDR(BYTE cl_color); // 
extern BOOL SetPaletteDDR(int N); //  (N: 0-bit332, 1-level676, 2-level666)

//----------    
extern BOOL OpenMemBufDDR();
//----------    RAM     
extern BOOL LockMemBufDDR();
//----------    RAM
extern BOOL UnlockMemBufDDR();
//----------    RAM  
extern BOOL CopyMemBufDDR();

//------------------

#endif