//----------  

#include "game_krn.h"


LPDIRECTDRAWSURFACE Blk_Spr[Max_Block]; //    


//----------  o 

void InitBlockSPR()
{
	for (int i=0;i<Max_Block;i++)
		Blk_Spr[i]=NULL;
}

//----------   

void DeleteBlockSPR(int n)
{
	if(Blk_Spr[n]==NULL) return;
	Blk_Spr[n]->Release();
	Blk_Spr[n]=NULL;
}

//----------  o    

void ShutDownBlockSPR()
{
	for (int i=0;i<Max_Block;i++)
		DeleteBlockSPR(i);
}

//----------  

int OpenBlockSPR(int w, int h) //:    -1
{
	for(int i=0;i<Max_Block;i++)
	{
		if(Blk_Spr[i]==NULL)
		{
			ZeroMemory(&dd_sd,sizeof(dd_sd));
			dd_sd.dwSize=sizeof(DDSURFACEDESC);
			dd_sd.dwFlags=DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT;
			dd_sd.ddsCaps.dwCaps=DDSCAPS_OFFSCREENPLAIN ;//| DDSCAPS_SYSTEMMEMORY; //!
			dd_sd.ddpfPixelFormat.dwSize=sizeof(DDPIXELFORMAT);
			dd_sd.ddpfPixelFormat.dwFlags=DDPF_RGB | DDPF_PALETTEINDEXED8;
			dd_sd.ddpfPixelFormat.dwRGBBitCount=8;
			dd_sd.dwWidth=w;
			dd_sd.dwHeight=h;
			dd_res=dd_obj->CreateSurface(&dd_sd,&Blk_Spr[i],NULL);
			if(dd_res!=DD_OK) 
				{ErrorDDR("openblk1"); return -1;}
			return i;
		}
	}
	return -1;
}

//----------       

char* LockBlockSPR(int n)
{
	ZeroMemory(&dd_sd,sizeof(DDSURFACEDESC));
	dd_sd.dwSize=sizeof(DDSURFACEDESC);
	do
	{
		dd_res=Blk_Spr[n]->Lock(NULL,&dd_sd,DDLOCK_SURFACEMEMORYPTR,NULL);
		if(dd_res==DD_OK)
		{
			// 
			return (char*) dd_sd.lpSurface;
		}
		if(dd_res==DDERR_SURFACELOST)
		{
			// 
			Blk_Spr[n]->Restore();
			continue;
		}
		if(dd_res!=DDERR_WASSTILLDRAWING) {ErrorDDR("lockblk1"); return NULL;}
	} while(1);
	
}

//----------  

void UnlockBlockSPR(int n, char* bsp)
{
	dd_res=Blk_Spr[n]->Unlock(bsp);
	if(dd_res==DD_OK) return;
	ErrorDDR("unlockblk1");
}

//----------       

BOOL CopySPR (int x,int y, int n, RECT* r) //x,y- , n- ,   
{
	dd_res=dd_buff->BltFast(x,y,Blk_Spr[n],r,DDBLTFAST_NOCOLORKEY | DDBLTFAST_WAIT);
	if(dd_res==DD_OK) return TRUE;
	if(dd_res==DDERR_INVALIDRECT)
	{
		return TRUE;
	}
	if(dd_res==DDERR_SURFACELOST)
	{
		//RestoreGFX();
		return TRUE;
	}
	ErrorDDR("copyspr1");
	return FALSE;
}

//----------       c   

BOOL BltSPR (int x,int y, int n,RECT* r) //x,y- , n- ,   
{
	dd_res=dd_buff_RAM->BltFast(x,y,Blk_Spr[n],r,DDBLTFAST_SRCCOLORKEY | DDBLTFAST_WAIT );
	if(dd_res==DD_OK) return TRUE;
	if(dd_res==DDERR_INVALIDRECT)
	{
		return TRUE;
	}
	if(dd_res==DDERR_SURFACELOST)
	{
		//RestoreGFX();
		return TRUE;
	}
	ErrorDDR("blitspr1");
	return FALSE;
}

//-----------     i

BOOL SetTransparentColorSPR(int i,int N) 
{
	dd_ckey.dwColorSpaceLowValue=N;
    dd_ckey.dwColorSpaceHighValue=N;
	dd_res=Blk_Spr[i]->SetColorKey(DDCKEY_SRCBLT, &dd_ckey);
	if(dd_res!=DD_OK){ErrorDDR("setckeySrc1"); return FALSE;}	
	return TRUE;
}

//---------- 
RGBQUAD bmpPAL[256];

int LoadBlockSPR(char *fname) //:    -1
{
	BITMAPFILEHEADER bmpFH;
	BITMAPINFOHEADER bmpINF;
	int nS;
	char *bmpDAT, *bDAT;

	int hi=_open(fname,_O_RDONLY | _O_BINARY);
	if (hi==-1) {Msg("Error open file:\r\n%s",fname);return -1;}
	_read(hi,&bmpFH,sizeof(BITMAPFILEHEADER));
	if (bmpFH.bfType!=0x4D42){Msg("No BMP file:\r\n%s",fname);return -1;}
	_read(hi,&bmpINF,sizeof(BITMAPINFOHEADER));
	if(bmpINF.biBitCount!=8){Msg("No 256 color BMP:\r\n%s",fname);return -1;}
	_read(hi,&bmpPAL,sizeof(bmpPAL));
	int w=bmpINF.biWidth;
	int h=bmpINF.biHeight;
	int sz=bmpINF.biSizeImage;
	nS=(OpenBlockSPR(w,h));
	if(nS==-1) {Msg("No mem for sprite surface");return -1;}
	bmpDAT=(char *)malloc(sz);
	if (bmpDAT==NULL) return -1;
	_read(hi,bmpDAT,sz);
	//Msg("BMP %ux%ux8bit (%u ) ",w,h,sz);
	bDAT=bmpDAT+w*(h-1);
	//copy DIB to surf
	char *b_surf=LockBlockSPR(nS);
	char *b_surf1=b_surf;
	for(int dh=0;dh<h;dh++)
	{
		memcpy(b_surf1,bDAT,w);
		b_surf1+=dd_sd.lPitch; //!!!Pitch,   Width
		bDAT-=w;
	}
	UnlockBlockSPR(nS,b_surf);
	free(bmpDAT);
	
	SetTransparentColorSPR(nS,0);
	return nS;
}